# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class OrganizationTeamInvite(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'role': 'str',
        'team': 'str'
    }

    attribute_map = {
        'role': 'role',
        'team': 'team'
    }

    def __init__(self, role='Member', team=None, _configuration=None):  # noqa: E501
        """OrganizationTeamInvite - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._role = None
        self._team = None
        self.discriminator = None

        if role is not None:
            self.role = role
        self.team = team

    @property
    def role(self):
        """Gets the role of this OrganizationTeamInvite.

        The role to be assigned to the invited user in the team.

        :return: The role of this OrganizationTeamInvite.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role):
        """Sets the role of this OrganizationTeamInvite.

        The role to be assigned to the invited user in the team.

        :param role: The role of this OrganizationTeamInvite.
        :type: str
        """
        allowed_values = ["Manager", "Member"]  # noqa: E501
        if (self._configuration.client_side_validation and
                role not in allowed_values):
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"  # noqa: E501
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def team(self):
        """Gets the team of this OrganizationTeamInvite.

        The team identifier (slug).

        :return: The team of this OrganizationTeamInvite.
        :rtype: str
        """
        return self._team

    @team.setter
    def team(self, team):
        """Sets the team of this OrganizationTeamInvite.

        The team identifier (slug).

        :param team: The team of this OrganizationTeamInvite.
        :type: str
        """
        if self._configuration.client_side_validation and team is None:
            raise ValueError("Invalid value for `team`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                team is not None and len(team) < 1):
            raise ValueError("Invalid value for `team`, length must be greater than or equal to `1`")  # noqa: E501
        if (self._configuration.client_side_validation and
                team is not None and not re.search('^[-a-zA-Z0-9_]+$', team)):  # noqa: E501
            raise ValueError(r"Invalid value for `team`, must be a follow pattern or equal to `/^[-a-zA-Z0-9_]+$/`")  # noqa: E501

        self._team = team

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrganizationTeamInvite, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrganizationTeamInvite):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrganizationTeamInvite):
            return True

        return self.to_dict() != other.to_dict()

