# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class ProviderSettingsRequestPatch(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'claims': 'object',
        'enabled': 'bool',
        'name': 'str',
        'provider_url': 'str',
        'service_accounts': 'list[str]'
    }

    attribute_map = {
        'claims': 'claims',
        'enabled': 'enabled',
        'name': 'name',
        'provider_url': 'provider_url',
        'service_accounts': 'service_accounts'
    }

    def __init__(self, claims=None, enabled=None, name=None, provider_url=None, service_accounts=None, _configuration=None):  # noqa: E501
        """ProviderSettingsRequestPatch - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._claims = None
        self._enabled = None
        self._name = None
        self._provider_url = None
        self._service_accounts = None
        self.discriminator = None

        if claims is not None:
            self.claims = claims
        if enabled is not None:
            self.enabled = enabled
        if name is not None:
            self.name = name
        if provider_url is not None:
            self.provider_url = provider_url
        if service_accounts is not None:
            self.service_accounts = service_accounts

    @property
    def claims(self):
        """Gets the claims of this ProviderSettingsRequestPatch.

        The set of claims that any received tokens from the provider must contain to authenticate as the configured service account.

        :return: The claims of this ProviderSettingsRequestPatch.
        :rtype: object
        """
        return self._claims

    @claims.setter
    def claims(self, claims):
        """Sets the claims of this ProviderSettingsRequestPatch.

        The set of claims that any received tokens from the provider must contain to authenticate as the configured service account.

        :param claims: The claims of this ProviderSettingsRequestPatch.
        :type: object
        """

        self._claims = claims

    @property
    def enabled(self):
        """Gets the enabled of this ProviderSettingsRequestPatch.

        Whether the provider settings should be used for incoming OIDC requests.

        :return: The enabled of this ProviderSettingsRequestPatch.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this ProviderSettingsRequestPatch.

        Whether the provider settings should be used for incoming OIDC requests.

        :param enabled: The enabled of this ProviderSettingsRequestPatch.
        :type: bool
        """

        self._enabled = enabled

    @property
    def name(self):
        """Gets the name of this ProviderSettingsRequestPatch.

        The name of the provider settings are being configured for

        :return: The name of this ProviderSettingsRequestPatch.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProviderSettingsRequestPatch.

        The name of the provider settings are being configured for

        :param name: The name of this ProviderSettingsRequestPatch.
        :type: str
        """
        if (self._configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def provider_url(self):
        """Gets the provider_url of this ProviderSettingsRequestPatch.

        The URL from the provider that serves as the base for the OpenID configuration. For example, if the OpenID configuration is available at https://token.actions.githubusercontent.com/.well-known/openid-configuration, the provider URL would be https://token.actions.githubusercontent.com/

        :return: The provider_url of this ProviderSettingsRequestPatch.
        :rtype: str
        """
        return self._provider_url

    @provider_url.setter
    def provider_url(self, provider_url):
        """Sets the provider_url of this ProviderSettingsRequestPatch.

        The URL from the provider that serves as the base for the OpenID configuration. For example, if the OpenID configuration is available at https://token.actions.githubusercontent.com/.well-known/openid-configuration, the provider URL would be https://token.actions.githubusercontent.com/

        :param provider_url: The provider_url of this ProviderSettingsRequestPatch.
        :type: str
        """
        if (self._configuration.client_side_validation and
                provider_url is not None and len(provider_url) < 1):
            raise ValueError("Invalid value for `provider_url`, length must be greater than or equal to `1`")  # noqa: E501

        self._provider_url = provider_url

    @property
    def service_accounts(self):
        """Gets the service_accounts of this ProviderSettingsRequestPatch.

        The service accounts associated with these provider settings

        :return: The service_accounts of this ProviderSettingsRequestPatch.
        :rtype: list[str]
        """
        return self._service_accounts

    @service_accounts.setter
    def service_accounts(self, service_accounts):
        """Sets the service_accounts of this ProviderSettingsRequestPatch.

        The service accounts associated with these provider settings

        :param service_accounts: The service_accounts of this ProviderSettingsRequestPatch.
        :type: list[str]
        """

        self._service_accounts = service_accounts

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProviderSettingsRequestPatch, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProviderSettingsRequestPatch):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProviderSettingsRequestPatch):
            return True

        return self.to_dict() != other.to_dict()

